#nanite_fight: loader.py
#By Shanti Pothapragada, rgbDreamer@gmail.com
#for pyweek 12: 'nine times'
#under GPL 3.0
import os

import pygame

from instructions import actions, conditions, calls, wait
from view_controller import images, beat, tileSize, screen, operations
from view_controller import load_image, font_big, choose_color

code_offset = (23, 2)
load_offset = 2,5
cancel_offset = 2,7 
files_offset = 13, 1
width = tileSize * 9
preview = None
scroll = 0
plr = 1
running = True
loaderbg = load_image("img/loader background.bmp", None)

def main(plr1):
	global plr, running, files
	plr = plr1
	files = os.listdir('saves')
	files = [file for file in files if file[-4:] == '.sav']
	running = True
	while running:
		draw_loader()
		handle_events()
	pygame.mixer.Channel(11).play(beat)

def draw_loader():
	global preview
	screen.blit(loaderbg, (0,0))
	#draw filenames:
	i = 0
	for file in files[scroll:scroll + 11]:
		screen.blit(font_big.render(file, True, (0,0,0)), 
					((files_offset[0] * tileSize, 
					(files_offset[1] + i) * tileSize)))
		i += 1
	#draw preview:
	if preview:
		for i in range(9):
			for j in range(9):
				screen.blit(images[preview[i][j]], 
					((j + code_offset[0]) * tileSize,
					 (i + code_offset[1]) * tileSize))
	pygame.display.flip()
	
				
				
				
				
def previewer(filename):
	global preview, color
	preview = [[],[],[],[],[],[],[],[],[]]
	for f in preview:
		f.extend([[],[],[],[],[],[],[],[],[]])
	try:
		file = open('saves/' + filename, 'r')
		for function in preview:
			data = file.readline()[:-1]
			data = data[:-1].split(',')
			for i in range(len(function)):
				function[i] = int_to_instruction(data[i])
		data = file.read()
		color = int(data)
		file.close()
	except IOError, ValueError:
		print 'bad file'
	
def load():
	operations[plr] = preview
	choose_color(plr, color)
	
	
	
def int_to_instruction(i):
	i = int(i)
	inst = []
	inst.extend(actions)
	inst.extend(calls)
	inst.extend(conditions)
	return inst[i]
	
	
def handle_events():
	global scroll, running
	for e in pygame.event.get():
		if e.type == pygame.QUIT:
			running = False
		elif e.type == pygame.MOUSEBUTTONDOWN:
			pos = int(e.pos[0] / tileSize), int(e.pos[1] / tileSize)
			if files_offset[0] < pos[0] < files_offset[0] + 9:
				#select files
				for i in range(min(len(files), 11)):
					if files_offset[1] + i == pos[1]:
					 	previewer(files[i + scroll])
						return
				#select scrollers
				if pos[1] == 0:
					scroll = max(scroll - 1, 0)
					return
				if pos[1] == 12:
					scroll = min(len(files) - 11, scroll + 1)
					return
			if load_offset[0] < pos[0] < load_offset[0] + 9:
				#select load
				if load_offset[1] == pos[1] and preview:
					load()
					running = False
					return
				#select cancel
				if cancel_offset[1] == pos[1]:
					running = False
					return
			
			
			
			
			
			
			
			
			
			